import copy

inf = 1000*1000


def translate(d, x, y):
    return set([(a+x, b+y) for a, b in d])


def get_max_min(d):
    X = []
    Y = []
    for x, y in d:
        X.append(x)
        Y.append(y)
    return (min(X), min(Y), max(X), max(Y))


def hw(S):
    min_x, min_y, max_x, max_y = get_max_min(S)
    return (max_x-min_x+1, max_y-min_y+1)


class Puzel:
    def __init__(self):
        self.S = set()

    def __str__(self):
        return ' '.join([str(self.w), str(self.h), str(self.S)])

    def read(self):
        n, _ = map(int, input().strip().split(" "))

        for i in range(0, n):
            t = input()
            for j, c in enumerate(t):
                if c == 'X':
                    self.S.add((i, j))

        min_x, min_y, _, __ = get_max_min(self.S)
        self.S = translate(self.S, -min_x, -min_y)
        self.h, self.w = hw(self.S)
        # print(self.S, self.h, self.w)

    def rotate(self):
        self.S = set([(self.w-y-1, x) for x, y in self.S])
        self.w, self.h = self.h, self.w

    def flip(self):
        self.S = set([(x, self.w-1-y) for x, y in self.S])

    def get_area(self):
        return len(self.S)

    def leftmost_x(self):
        for j in range(0, inf):
            for i in range(0, self.h):
                if (i, j) in self.S:
                    return (i, j)

    def leftmost_dot(self):
        for j in range(0, inf):
            for i in range(0, self.h):
                if (i, j) not in self.S:
                    return (i, j)


def is_rectangle(S):
    h, w = hw(S)
    return h*w == len(S)


def ok(A,  B):
    area = A.get_area()+B.get_area()

    x1, y1 = A.leftmost_dot()
    x2, y2 = B.leftmost_x()

    shift = (x1-x2, y1-y2)

    sx, sy = shift

    T = translate(B.S, sx, sy)

    union = set.union(T, A.S)

    return is_rectangle(union) and len(union) == area


def get_all(P):
    res = []
    for _ in range(0, 4):
        res.append(copy.deepcopy(P))
        P.rotate()
    P.flip()
    for _ in range(0, 4):
        res.append(copy.deepcopy(P))
        P.rotate()
    return res


def sol(A, B):
    XA = get_all(A)
    XB = get_all(B)
    for a in XA:
        for b in XB:
            if ok(a, b) or ok(b, a):
                return True

    return False


def solve():
    A = Puzel()
    B = Puzel()
    A.read()
    B.read()

    print("TAK" if sol(A, B) else "NIE")


Z = int(input())
for _ in range(0, Z):
    solve()
